org $0FF000

!muncher = $80
!1up = $40
!spiny = $40

assert !muncher+!1up+!spiny = $100

pushpc
org $01EA52
JML lakituthrow

org $01EA05
LDA $13
AND #$3F ; throw twice as often
pullpc

lakituthrow:
LDA $13BF
CMP #$29
BEQ .hack
.spiny
JSL $07F7D2
JML $01EA56

.hack
CPX #$01
BCC .muncher ; if low on slots, always use the muncher

;otherwise, pick something at random
JSL $01ACF9
LDA $148D
EOR $14E0,x

CMP.b #$100-!1up ; 1up probability must be nonzero, but player needs some reward anyways.
BCS ._1up

CMP.b #$100-!1up-!spiny
BCS .spiny

.muncher
JSL $07F7D2

; aim better
LDA $14E0,x
XBA
LDA $E4,x
REP #$21
LDY #$00
SBC $94
BPL +
INY
EOR #$FFFF
+
STA $4204
SEP #$20

LDA #$05 ; muncher is in air roughly #$50 frames. speed is in 16ths of pixels, so this is close enough
STA $4206

INC $C2,x ; 6 cycles (sum 6 of 16)
LDA #$D8  ; 2 cycles (sum 8)
STA $AA,x ; 4 cycles (sum 12)
NOP       ; 2 cycles (sum 14)

LDA $4214 ; 3 cycles before reading the result (sum 17 >= 16)
DEY
BEQ +
EOR #$FF
INC A
+
STA $B6,x

JML $01EA60

._1up
LDA #$78
STA $9E,x
JSL $07F7D2
JML $01EA56



pushpc
org $01849B
JSL lakituinvuln
pullpc
lakituinvuln:
LDA $13BF
CMP #$29
BNE +
LDA $167A,x
ORA #$80
STA $167A,x
+
JML $02A9E4



pushpc
org $018C30
JSL spinyground
pullpc

spinyground:
LDA $13BF
CMP #$29
BEQ .hack
.orig
LDA #$13
STA $9E,x
RTL

.hack:
LDA $C2,x
BEQ .orig

LDA $14E0,x
XBA
LDA $E4,x
REP #$21
ADC #$0008
CMP #$0100
SEP #$20
BCC .do
.done
; offscreen
LDX $15E9
INC $14D4,x ; can't despawn it, it resets the sprite tables. dump it offscreen instead
RTL

.do
LSR #4
ORA #$D0

.higher
TAX
LDA $7EC800,x
CMP #$2F
BNE .spawn
TXA
SEC
SBC #$10
BRA .higher

.spawn
LDA #$01
STA $7FC800,x
LDA #$2F
STA $7EC800,x

;make sure things don't get stuck inside munchers
STX $00
LDY #$0B
.moveloop
LDA $00E4,y
SEC
SBC #$08
LSR #4
STA $01
LDA $00D8,y
AND #$F0
ORA $01
TAX
LDA $7EC800,x
CMP #$2F
BNE .notinside
LDA $7EC801,x
CMP #$2F
BNE .notinside
LDA $00D8,y
SEC
SBC #$10
STA $00D8,y
.notinside
DEY
BPL .moveloop
LDX $00

CPX #$D0
BCS .hard

REP #$30
TXA
AND #$00F0
ASL A
ASL A
STA $00
TXA
AND #$000F
ASL A
TSB $00

LDA $7F837B
TAX ; don't bother storing it back, the only other vram change right now is status bar and it's not a stripe.

LDA $00
XBA
ORA #$0020
STA $7F837D+0+0,x
LDA #$0380
STA $7F837D+0+2,x
LDA #$185C
STA $7F837D+0+4,x
LDA #$185E
STA $7F837D+0+6,x

LDA $00
XBA
ORA #$0120
STA $7F837D+8+0,x
LDA #$0380
STA $7F837D+8+2,x
LDA #$185D
STA $7F837D+8+4,x
LDA #$185F
STA $7F837D+8+6,x

LDA #$FFFF
STA $7F837D+16,x

SEP #$30
LDX $15E9
INC $14D4,x ; can't despawn it, it resets the sprite tables. dump it offscreen instead
RTL


.hard

TXA
AND #$0F
ASL A
TAY

ASL #3
STA $9A
LDA #$D0
STA $98
STZ $99
STZ $9B
JSL $028A44
LDA #$08
STA $1DF9

LDA $7EC800-1,x
STA $00
STZ $01
LDA $7EC800+1,x
STA $02
STZ $03

REP #$30

LDA $7F837B
TAX

REP #$30
LDA $00
CMP #$002F
BEQ .noleftwall

TYA
DEC A
BMI .noleftwall
XBA
ORA #$4023
STA $7F837D+0,x
LDA #$0580
STA $7F837D+2,x
LDA #$1D01
STA $7F837D+4,x
LDA #$1D88
STA $7F837D+6,x
LDA #$1D89
STA $7F837D+8,x
TXA
CLC
ADC #$000A
TAX
.noleftwall

LDA $02
CMP #$002F
BEQ .norightwall

TYA
INC #2
CMP #$0020
BCS .norightwall
XBA
ORA #$4023
STA $7F837D+0,x
LDA #$0580
STA $7F837D+2,x
LDA #$1D00
STA $7F837D+4,x
LDA #$DD88
STA $7F837D+6,x
LDA #$1D8A
STA $7F837D+8,x
TXA
CLC
ADC #$000A
TAX
.norightwall

TYA
XBA
ORA #$4023
STA $7F837D+0,x
ORA #$0100
STA $7F837D+10,x

LDA #$0580
STA $7F837D+2,x
LDA #$185C
STA $7F837D+4,x
LDA #$185E
STA $7F837D+6,x
LDA #$DD84
STA $7F837D+8,x

LDA #$0580
STA $7F837D+12,x
LDA #$185D
STA $7F837D+14,x
LDA #$185F
STA $7F837D+16,x
LDA #$DD85
STA $7F837D+18,x

LDA #$FFFF
STA $7F837D+20,x

SEP #$30
LDX $15E9
INC $14D4,x
RTL



pushpc
org $018C47
JMP spinygfx

org $01FFBF ; need it in bank 1 because GetDrawInfo suicides otherwise
spinygfx:
LDA $C2,x
BNE .hack
LDA #$02
JMP $9CF3 ; SubSprGfx0Entry0


.hack ; totally not an anime reference

JSR $A365

LDY $15EA,x
LDA $00
STA $0300,y
LDA $01
STA $0301,y
LDA $14
LSR
LSR
DEC A ; sync with the real munchers
AND #$02
STA $0302,y

LDA $14
ASL #4
AND #$80
ORA #$0F ; yxppCCCT
ORA $64
STA $0303,y

LDA #$00 ; 1 tile
LDY #$02 ; 16x16
JMP $B7BB ; FinishOAMWriteRt
pullpc



pushpc
org $00D0CB
JSL reincarnate
NOP
pullpc
reincarnate:
LDA $13BF
CMP #$29
BNE .boringdeath
INC $0DBE
.boringdeath
LDA #$80
STA $0DD5
RTL

pushpc
org $00F60A
JSL loldead
NOP
pullpc
loldead:
LDA $13BF
CMP #$29
BEQ .fancydeath
LDA #$09
BRA +

.fancydeath
LDA #$14
+
STA $1DFB
RTL




;time up fix patch
;by myself, how convenient
pushpc
org $008E21
JML TickTime

org $008E4F
BNE TimeIsntZero

org $008E60
LDA $0F32
ORA $0F33
BNE TimeIsntZero
LDA #$FF
NOP
JSL TimeUp
TimeIsntZero:

org $00D0E6
JSL CheckIfTimeUpMsg
NOP
pullpc

TickTime:
LDA $0D9B
CMP #$C1
BEQ .DontTick
LDA $0F30
BMI .DontTick
JML $008E28
.DontTick
JML $008E6F

TimeUp:
STA $0F30
JML $00F606

CheckIfTimeUpMsg:
LDY #$0B
LDA $0F31
LDX $0F30
BMI .DoTimeUp
INC A
.DoTimeUp
RTL



;replace level
pushpc
org $0688DD : db $A0,$00,$70,$20,$04 : db $6D,$D0,$2F : db $FF
org $05E90F : dl $FFE674
org $07C4CA : db $00 : db $20,$80,$1E : db $FF
org $05F105 : db $05
org $05F305 : db $05
org $05F505 : db $03
org $05F705 : db $00
pullpc

;replace graphics
pushpc
org $00AA80
JSL graphics
NOP
pullpc
graphics:
LDA $13BF
CMP #$29
BNE .boring

CPY #$1B
BNE +
REP #$30
PHB
LDX.w #.fg
LDY.w #$AD00
LDA.w #$36-1
MVN $7E,.fg>>16
SEP #$30
PLB
+

CPY #$13
BNE +
PHB
REP #$30
LDX.w #.sp1
LDY.w #$AD00
LDA.w #.sp2-.sp1-1
MVN $7E,.sp1>>16
;LDX.w #.sp2
LDY.w #$AD00+$180
LDA.w #.sp2-.sp1-1
MVN $7E,.sp2>>16
SEP #$30
PLB
+

.boring
REP #$20
TDC
RTL

.fg ; replaces GFX1B
db $00,$0F,$00,$3F,$03,$7C,$17,$68,$00,$FF,$10,$EF,$30,$CF,$30,$CF
db $00,    $00,    $03,    $07,    $0F,    $1F,    $3F,    $3F
db $00,$F0,$00,$FC,$E0,$1E,$F0,$0E,$08,$F7,$1C,$E3,$3C,$C3,$7C,$83
db $00,    $00,    $E0,    $F0,    $E0,    $C0,    $80,    $00
.sp1 ; replaces GFX13
db $00,$80,$00,$C0,$40,$A0,$40,$B0,$40,$F8,$20,$7C,$00,$7E,$00,$3F ; muncher
db $00,    $00,    $00,    $00,    $40,    $20,    $20,    $10
db $00,$01,$00,$03,$02,$05,$04,$0B,$08,$1F,$10,$3E,$00,$7E,$00,$FC
db $00,    $00,    $00,    $00,    $08,    $10,    $20,    $40
db $00,$01,$01,$02,$01,$02,$02,$05,$02,$07,$02,$0F,$00,$0F,$00,$0F
db $00,    $00,    $00,    $00,    $02,    $02,    $04,    $04
db $00,$80,$00,$C0,$00,$C0,$00,$E0,$00,$E0,$00,$F0,$00,$F0,$00,$F0
db $00,    $00,    $00,    $00,    $00,    $00,    $00,    $00

;db $02,$18,$0A,$1D,$02,$1D,$05,$2B,$2B,$77,$57,$EF,$1D,$ED,$2A,$D8 ; rotated spiny
;db $00,    $09,    $01,    $12,    $06,    $0F,    $0B,    $15
;db $00,$00,$00,$00,$D8,$C0,$E0,$00,$20,$20,$C0,$C0,$B0,$F0,$FA,$C0
;db $00,    $00,    $38,    $10,    $C0,    $00,    $C8,    $86
;db $02,$18,$0A,$DD,$02,$BD,$45,$DB,$6B,$F7,$17,$6F,$1D,$6D,$2A,$58
;db $00,    $09,    $41,    $22,    $06,    $0F,    $0B,    $15
;db $00,$00,$00,$00,$D8,$C0,$E0,$00,$20,$20,$C0,$C0,$B0,$F0,$FA,$C0
;db $00,    $00,    $38,    $10,    $C0,    $00,    $C8,    $86

.sp2 ; replaces GFX13, offset 0x180
db $00,$3F,$00,$1F,$00,$0F,$70,$73,$E9,$FB,$56,$6F,$3A,$3D,$07,$07
db $00,    $00,    $00,    $00,    $71,    $39,    $07,    $00
db $00,$FC,$00,$F8,$00,$F0,$0E,$CE,$17,$DF,$6A,$F6,$5C,$BC,$E0,$E0
db $00,    $00,    $00,    $00,    $8E,    $9C,    $E0,    $00
db $00,$0F,$00,$0F,$00,$07,$70,$77,$E8,$FB,$55,$6F,$3A,$3D,$07,$07
db $00,    $00,    $00,    $00,    $70,    $39,    $07,    $00
db $00,$F0,$00,$F0,$00,$E0,$0E,$EE,$17,$DF,$2A,$F6,$5C,$BC,$E0,$E0
db $00,    $00,    $00,    $00,    $0E,    $9C,    $E0,    $00

;db $2B,$58,$2C,$5C,$2F,$DF,$57,$EF,$77,$EF,$0B,$57,$08,$37,$08,$14
;db $14,    $13,    $19,    $0F,    $0E,    $26,    $07,    $04
;db $FF,$40,$CA,$C0,$B0,$F0,$C0,$C0,$E0,$20,$20,$00,$D8,$C0,$00,$00
;db $81,    $B6,    $C8,    $00,    $00,    $D0,    $38,    $00
;db $2B,$58,$2C,$5C,$2F,$5F,$17,$6F,$37,$EF,$4B,$D7,$08,$B7,$08,$D4
;db $14,    $13,    $19,    $0F,    $0E,    $26,    $47,    $04
;db $FF,$40,$CA,$C0,$B0,$F0,$C0,$C0,$E0,$20,$20,$00,$D8,$C0,$00,$00
;db $81,    $B6,    $C8,    $00,    $00,    $D0,    $38,    $00

;replace palette F
pushpc
org $00ACE2
JSL palette
NOP
pullpc
palette:
LDA #$0002
STA $08

LDA $13BF
CMP #$0029
BNE +
PHB
LDX #$07C3 ; just copy from palette 6
LDY #$08E3
LDA #$0010
MVN $7E,$7E
PLB
+
RTL



;fix random bugs
pushpc
; mario start palette
org $00913F : db $34
org $009170 : db $F4
; mario position (ow)
org $009EF6
dw $0038,$0088,$0038,$0088
dw $0003,$0008,$0003,$0008
; remove useless delay on welcome to dinosaur land
org $00A09B : LDA #$01
pullpc
