!cluster_sprite_x_pos_hi = $1E3E
!cluster_sprite_x_pos_lo = $1E16
!cluster_sprite_y_pos_hi = $1E2A
!cluster_sprite_y_pos_lo = $1E02

!cluster_sprite_y_speed = $1E52
!cluster_sprite_x_speed = $1E66
!cluster_sprite_x_speed_acc = $1E8E
!cluster_sprite_y_speed_acc = $0F72

!cluster_sprite_number = $1892

!time_to_live = #$40
!frame_counter = $0F4A
!frame = $1E7A

Main:				;The code always starts at this label in all sprites.
	lda $9D
	bne .dont_move

	;lda !alive_counter,y
	;bne +
	;	lda #$00
	;	sta !cluster_sprite_number,y
	;+
	;dec
	;sta !alive_counter,y
	lda $14
	lsr #3
	and #$03
	sta !frame,y

	lda !cluster_sprite_y_speed_acc,y
	sta $00
	lda !cluster_sprite_y_speed,y
	jsr do_movement
	lda $00
	sta !cluster_sprite_y_speed_acc,y
	lda !cluster_sprite_y_pos_lo,y
	clc
	adc $01
	sta !cluster_sprite_y_pos_lo,y
	lda $01
	bpl .positive_y
	lda !cluster_sprite_y_pos_hi,y
	sbc #$00
	sta !cluster_sprite_y_pos_hi,y
	bra .done_high_byte_y
	.positive_y
	lda !cluster_sprite_y_pos_hi,y
	adc #$00
	sta !cluster_sprite_y_pos_hi,y
	.done_high_byte_y


	lda !cluster_sprite_x_speed_acc,y
	sta $00
	lda !cluster_sprite_x_speed,y
	jsr do_movement
	lda $00
	sta !cluster_sprite_x_speed_acc,y
	lda !cluster_sprite_x_pos_lo,y
	clc
	adc $01
	sta !cluster_sprite_x_pos_lo,y
	lda $01
	bpl .positive_x
	lda !cluster_sprite_x_pos_hi,y
	sbc #$00
	sta !cluster_sprite_x_pos_hi,y
	bra .done_high_byte_x
	.positive_x
	lda !cluster_sprite_x_pos_hi,y
	adc #$00
	sta !cluster_sprite_x_pos_hi,y
	.done_high_byte_x

	jsr do_gravity

	jsr check_offscreen

	.dont_move
	jsr Draw

	rts

do_movement:
	stz $01
	clc
	adc $00
	bmi +
	jmp add_speed
	+
	jmp subtract_speed

subtract_speed:
	beq +
	cmp #$F1
	bcs +
		dec $01
		clc
		adc #$10
		bra subtract_speed
	+
	sta $00
	rts
add_speed:
	beq +
	cmp #$10
	bcc +
		inc $01
		sec
		sbc #$10
		bra add_speed
	+
	sta $00
	rts

!max_speed = #$40
!gravity = #$03

do_gravity:
	lda !cluster_sprite_y_speed,y
	bmi .going_up
		cmp.b !max_speed
		bcc .going_up
			lda !max_speed
			sta !cluster_sprite_y_speed,y
			bra .done
	.going_up
	clc
	adc !gravity
	sta !cluster_sprite_y_speed,y
	.done
	rts

check_offscreen:
	sta $7FA000
	lda !cluster_sprite_y_pos_hi,y
	xba
	lda !cluster_sprite_y_pos_lo,y
	rep #$20
	sec
	sbc $1C
	cmp.w #$00F0
	sep #$20
	bmi +
		lda #$00
		sta !cluster_sprite_number,y
	+

	lda !cluster_sprite_x_pos_hi,y
	xba
	lda !cluster_sprite_x_pos_lo,y
	rep #$20
	sec
	sbc $1A
	bmi .x_left
	.x_right
	cmp.w #$00F8
	sep #$20
	bcc +
		lda #$00
		sta !cluster_sprite_number,y
	+
	bra .done_x

	.x_left
	cmp.w #$FFF0
	sep #$20
	bcs +
		lda #$00
		sta !cluster_sprite_number,y
	+
	;bra .done_x

	.done_x

	rts

; Maybe fuck with this
OAMStuff:
db $B0,$B4,$B8,$BC,$C0,$C4,$C8,$CC,$D0,$D4,$D8,$DC,$80,$84,$88,$8C,$40,$44,$48,$4C ; These are all in $02xx

tiles:
	db $22,$24,$26,$24

!props = #%00110101
!size = #$02

Draw:                       ; OAM routine starts here.
jsr get_draw_info
LDX.w OAMStuff,y 		; Get OAM index.
lda $00
STA $0200,x			; /
lda $01
sta $0201,x
phx
ldx !frame,y
LDA tiles,x		; \ Tile
plx
STA $0202,x                     ; /
LDA.b !props
STA $0203,x
PHX
TXA
LSR
LSR
TAX
LDA !size
ora $02
STA $0420,x
PLX

ReturnToTheChocolateWhatever:
RTS

get_draw_info:
	stz $02
	lda !cluster_sprite_y_pos_hi,y
	xba
	lda !cluster_sprite_y_pos_lo,y
	rep #$20
	sec
	sbc $1C
	sep #$20
	sta $01

	lda !cluster_sprite_x_pos_hi,y
	xba
	lda !cluster_sprite_x_pos_lo,y
	rep #$20
	sec
	sbc $1A
	sep #$20
	sta $00
	bpl +
		lda #$01
		sta $02
	+
	rts
