

	;Constants
	!Length				= $06		;how many blocks wide the whole thing is.
	!Height				= $05

	!Enum_Input			= #$00	; values for !State=$C2
	!Enum_GoDown		= #$01
	!Enum_WaitForItem	= #$02
	!Enum_GoUp			= #$03
	!Enum_GoLeft		= #$04
	!Enum_End			= #$05
	!Enum_Return		= #$06
		
	
	!PrizeFlag 		= $58
	!State			= $C2
	
	;stuff for the crane
	!PositionX		= $151C
	!CraneLength	= $1510
	!PickedUpSpr	= $1534
	
	;stuff for the rotating prizes
	!StartPointer	= $1504
	!XSpeed			= $B6
	!XOffset			= $1528
	

print "INIT ",pc
	LDA #$FF			; \ initial speed (-1)
	STA $B6,x		; /
	
	STZ !XOffset,x
	STZ !StartPointer,x
	STZ !State,x
	
	STZ !PositionX,x
	LDA #$08
	STA !PickedUpSpr,x	
	LDA #$04
	STA !CraneLength,x
		
	;LDA #$97			; \
	;STA !PrizeFlag	; / DEBUG
	RTL
	
print "MAIN ",pc
	PHB : PHK : PLB
	JSR Sprite
	PLB
	RTL
	
Sprite:

	LDA $14C8,x		; \
	CMP #$08			; |
	BNE .return		; | return if locked or stuff...
	LDA $9D			; |
	BNE .return		; /
		
	JSR MainCode	; main code			
	
.return
	JSR MovePrizes	; makes the prizes go mary-go-round
	JSR Graphics	; draw the whole damn thing	
Return:

	LDA #$01
	STA $76
	STZ $7B
	STZ $7D
	
	LDA #$FF
	STA $0DAA
	STA $0DAB
	STA $0DAC
	STA $0DAD
	
	RTS

		
	
MainCode:
	LDA !State,x	; \ execute pointer
	JSL $0086DF		; /
	
	dw TakeControllerInput
	dw GoDown
	dw WaitForItem
	dw GoUp
	dw GoLeft
	dw End
	dw Return
	

CraneSpeed:
	db $00,$01,$FF,$00	
	
TakeControllerInput:	
	LDA !PositionX,x			; \
	STA $02						; |
	PHX							; |
	LDA $15						; | update position if pressing left or right.
	AND #$03						; |
	TAX							; |
	LDA CraneSpeed,x			; |
	PLX							; /
	
	CLC : ADC $02				; \
	BMI +							; | store only if value inbetween 00 and length
	CMP.b #!Length-$1*$10	; | (mind that xkas/asar is doing left through right math.
	BCS +							; |
	STA !PositionX,x			; /
+
	BIT $15						; \ check if A or B is pressed
	BPL +							; / skip if not
	LDA !Enum_GoDown			; \ set next state
	STA !State,x				; /
+	
	RTS
	
End:

	LDA !PickedUpSpr,x	;
	CMP #$08					;
	BEQ .return				;

	LDA $186C,x				; offscreen flag
	BNE .return
	JSL $02A9DE				; find free sprite slot in Y (=A)
	BMI .return				; FF if non found
	
	LDA #$01					; \ init sprite state
	STA $14C8,y				; /		
	
	LDA !PickedUpSpr,x
	PHX						; \
	TAX						; |
	LDA .PrizeSprite,x	; | sprite number from table
	STA $009E,y				; |
	PLX						; /
		
	LDA $E4,x
	SEC
	SBC #$40	
	STA $00E4,y
	
	LDA $14E0,x
	STA $14E0,y
	
	LDA $D8,x
	CLC : ADC #$10
	STA $00D8,y
	
	LDA $14D4,x
	STA $14D4,y
	
	PHX
	TYX
	JSL $07F7D2				; inits and resets tables
	PLX

	LDA #$01					; \ blinking flag for the power up.
	STA $1534,y				; /
	
	LDA #$0C
	STA $1DFC
	
	LDA #$08
	STA !PickedUpSpr,x	;
	
	
.return
	LDA $14AB
	BNE +
	LDA #$70					; \
	STA $14AB				; / bonus game ending timer
+
	LDA !Enum_Return		; \ set next state
	STA !State,x			; /
	RTS
	
;sprite numbers to the GFX below
.PrizeSprite
	db $77,$74,$75,$78,$77,$74,$75,$78
	
GoDown:
	LDA $14						; \
	AND #$01						; | only move every second frame
	BEQ .skip					; /
	
	LDA !CraneLength,x		; \
	CLC							; | add to rope length
	ADC CraneSpeed+$1			; /
	CMP.b #!Height*$10		; \ branch if less than 3 blocks long
	BCC +							; /
	LDA !Enum_WaitForItem	; \ set next state
	STA !State,x				; /
	LDA.b #!Height*$10		; set length to 3 blocks
+	STA !CraneLength,x
.skip
	RTS
	
GoUp:
	LDA $14						; \
	AND #$01						; | only move every second frame
	BEQ .skip					; /
	
	LDA !CraneLength,x		; \
	CLC							; | add to rope length
	ADC CraneSpeed+$2			; /
	BPL +							; if still positive, branch. If not...
	LDA !Enum_GoLeft			; \ set next state
	STA !State,x				; /
	LDA #$00						; set length to zero
+	STA !CraneLength,x
.skip
	RTS
	
GoLeft:
	LDA !PositionX,x			; \
	CLC							; | move crane to the left
	ADC CraneSpeed+$2			; |
	STA !PositionX,x			; /
	CMP #$C0						; \ far enough yet?
	BNE +							; / branch if no
	
	;LDA #$D0					; \ force set the position
	;STA !PositionX,x			; /
	LDA !Enum_End				; \ set next state
	STA !State,x				; /
+
	RTS
	
	
WaitForItem:
	LDA !PositionX,x			; \ crane position - the offset of the first prize
	SEC							; | = the total distance from the left border of the prizes to the crane
	SBC !XOffset,x				; /   distance is in pixel, I want it in blocks though (and rounded)
	
	LSR #4						; \ shift out the low nibble.
	BCC +							; | if the last shifted bit (now in carry) was 1, the nibble had a value of 8+
	INC							; / thus, we round up by increasing once.
+
	CLC							; \ add to whatever the first tile is
	ADC !StartPointer,x		; | modolo 8
	AND #$07						; /
	
	PHX : TAX
	
	LDA !PrizeFlag				; \
	AND Mask,x					; | check if the crane picked up an item
	BEQ .empty					; /
	
	LDA Mask,x					; \
	TRB !PrizeFlag				; / remove index from the flags
	
	TXA : PLX	
	
	STA !PickedUpSpr,x		; store index to the picked up sprite
	LDA #$29						; \ correct SFX
	STA $1DFC					; /
	BRA .return
	
.empty
	LDA #$2A						; \ wrong SFX
	STA $1DFC					; /
	LDA #$50						; \
	STA $14AB					; / bonus game ending timer
	PLX							; restore sprite index
.return
	LDA !Enum_GoUp				; \ set next state
	STA !State,x				; /	
	RTS
	
		
MovePrizes:
	LDA !XSpeed,x				; \ add speed to offset
	CLC : ADC !XOffset,x		; /
	CMP #$F0						; \
	BCS +							; |
	;CLC							; | if it's less than #$F0, add #$10
	ADC #$10						; /
	PHA
	
	LDA !StartPointer,x		; \
	INC							; | increase start pointer modolo 8.
	AND #$07						; |
	STA !StartPointer,x		; /	
	PLA
+
	STA !XOffset,x
	RTS	
	
	
;============================================================================
; The whole graphics routine... kinda seperated from the rest.
;============================================================================
	
Graphics:
	JSL GET_DRAW_INFO		; get indexes for OAM writing
	STZ $03					; $03 = counter for number of sprites drawn
		
	JSR .drawCrane			; self explaining?
	
	LDA $01						; \
	CLC							; |
	ADC.b #!Height+$1*$10	; | move position blocks lower
	STA $01						; /
	
	JSR .drawPrices		; more self explaining?
	
	LDA $03					; load number of sprites drawn
	BEQ +						; skip if none
	DEC						; routine needs number -1	
	LDY #$02					; we drew 16x16 tiles
	JSL $01B7B3				; routine to fill size
+
	RTS
	
	
	
.drawCrane	
	LDA !CraneLength,x			; \ crane (rope) length in $02
	STA $02							; /
	LDA !PositionX,x
	STA $04
	
	;------- draw the machine ----------------------------------------
	PHX								; save sprite index
	LDA $14							; \
	LSR #2							; | get index for animated tile
	AND #$03							; |
	TAX								; /
	
	LDA $00							; \
	CLC : ADC $04
	STA $0300,y						; |
	LDA $01							; |
	STA $0301,y						; | basic loading and storing
	LDA .CraneGFX,x				; | of position, tile and property
	STA $0302,y						; | for machine
	LDA .CraneProp,x				; |
	STA $0303,y						; /
	INY : INY : INY : INY		; increase OAM index
	INC $03							; increase tile counter
	PLX								; retore sprite index
		
	;------- draw the claw -------------------------------------------
	LDA $00	
	CLC : ADC $04
	STA $0300,y
	LDA $01
	CLC : ADC #$10					; one block below the machine
	CLC : ADC $02					; + however long the rope is
	STA $0301,y
	LDA .CraneGFX+$5				; claw tile
	
	
	PHA								; save tile	
	LDA !PickedUpSpr,x			; \
	CMP #$08							; | if we actually got a sprite, skip
	BNE +								; /
	LDA !State,x					; \
	CMP !Enum_GoUp					; | or if we aren't in the returning state yet
	BCC +								; /
	PLA								; \ to sum up, if we didn't catch an item,
	INC : INC						; | use the next 16x16 tile to the right
	PHA								; / save new tile
+	PLA								; load tile	
	
	STA $0302,y						; \ claw tile + prop
	LDA .CraneProp+$5				; |
	STA $0303,y						; /
	INY : INY : INY : INY		; increase OAM index
	INC $03							; increase tile counter
		
	;------- draw the picked up sprite -------------------------------
	
	LDA !PickedUpSpr,x
	CMP #$08
	BEQ +	
	PHX : TAX
	
	LDA $00	
	CLC : ADC $04
	STA $0300,y
	LDA $01
	CLC : ADC #$10					; one block below the machine
	CLC : ADC $02					; + however long the rope is
	STA $0301,y						; same pos as the claw
	LDA .PrizesGFX,x				; \
	STA $0302,y						; | price tile + prop
	LDA .PrizesProp,x				; |
	STA $0303,y						; /
	INY : INY : INY : INY		; increase OAM index
	INC $03							; increase tile counter
	PLX
+
	
	;------- draw the rope -------------------------------------------
	LDA $02
	BEQ +
-
	LDA $00
	CLC : ADC $04
	STA $0300,y
	LDA $01
	CLC : ADC $02					; add crane length
	STA $0301,y
	LDA .CraneGFX+$4
	STA $0302,y
	LDA .CraneProp+$4
	STA $0303,y	
	INY : INY : INY : INY		; increase OAM index
	INC $03							; increase tile counter
		
	LDA $02							; \ subtract 1 block from the rope length
	SEC : SBC #$10					; |
	STA $02							; /
	BEQ +								; if it's now 0, skip
	BPL -								; if it's still positive, repeat drawing rope
+		
	RTS	

.CraneGFX
	db $E0,$C2,$C0,$C2	;machine
	db $CE					;rope
	db $C4					;claw
.CraneProp
	db $37,$37,$37,$37	;machine
	db $01					;rope
	db $03					;claw
	
	
.drawPrices	
	LDA !PrizeFlag			; \ no prizes?
	BEQ .returnPrice		; / fuck this shit
	
	LDA $00					; \
	CLC : ADC !XOffset,x	; | add offset to x position.
	STA $00					; /
	
	LDA !StartPointer,x
	STA $02					; $02 = rotating flag	
	LDA #!Length			; times to loop -1
	STA $04					; $04 = loop counter
	
	PHX
	LDX $02	
	
-	LDA !PrizeFlag
	AND Mask,x			; \ check if flag is set
	BEQ +					; / if not, skip drawing the tile
	
	LDA $00
	STA $0300,y
	LDA $01
	STA $0301,y
	
	LDA .PrizesGFX,x
	STA $0302,y
	LDA .PrizesProp,x
	STA $0303,y
	INY : INY : INY : INY	; \ increase OAM index
	INC $03						; / incease sprite counter
+	
	LDA $00			; \
	CLC : ADC #$10	; | move one block to the right
	STA $00			; /
	
	TXA				; \
	INC				; |
	AND #$07			; |  (x++) mod 8
	TAX				; /
	
	DEC $04			; decrease loop counter
	BPL -				; repeat while positive
	PLX
.returnPrice
	RTS
	
; order = feather, muchroom, florwer, 1-up (repeat once)
.PrizesGFX
	db $0E,$24,$26,$24,$0E,$24,$26,$24	;
.PrizesProp
	db $04,$08,$0A,$0A,$04,$08,$0A,$0A	;,

	
Mask:
	db $01,$02,$04,$08,$10,$20,$40,$80
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SPR_T1:              db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040            ;  |
                    CMP #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTL                     ; return

INVALID:             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTL                     ; /