@include
; subroutine code goes here

; exit conditions:
;	Y = OAM index
;	$00 = X position relative to the screen
;	$01 = Y position relative to the screen
get_draw_info:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ .on_screen_X
	INC $15A0,x

.on_screen_X
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC #$0040
	CMP #$0180
	SEP #$20
	ROL
	AND #$01
	STA $15C4,x
	BNE .invalid

	PHB
	PHK
	PLB
	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ .loop
	INY
.loop
	LDA $D8,x
	CLC
	ADC .data_1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ .on_screen_Y
	LDA $186C,x
	ORA .data_2,y
	STA $186C,x
	
.on_screen_Y
	DEY
	BPL .loop
	PLB
	
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTL

.invalid
	PLA			; destroy the JSL
	PLA
	PLA
	PLA			; sneak in the bank
	PLY
	PHB
	PHY
	PHA
	RTL

.data_1
	db $0C,$1C
.data_2
	db $01,$02

; handles sprites going offscreen
; entry conditions:
;	A = X0, X1, X2, X3 stuff, but multiplied by 2
off_screen:
	PHB
	PHK
	PLB
	STA $03
	LDA $15A0,x
	ORA $186C,x
	BEQ .return
	LDA $5B
	AND #$01
	BNE .vertical_level
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL .erase_sprite
	LDA $167A,x
	AND #$04
	BNE .return
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC .data_3,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC .data_4,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC +
	EOR #$80
	STA $00
+	LDA $00
	BPL .return
.erase_sprite
	LDA $14C8,x
	CMP #$08
	BCC .kill_sprite
	LDY $161A,x
	CPY #$FF
	BEQ .kill_sprite
	LDA #$00
	STA $1938,y
.kill_sprite
	STZ $14C8,x
.return
	PLB
	RTL

.vertical_level
	LDA $167A,x
	AND #$04
	BNE .return
	LDA $13
	LSR
	BCS .return
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS .erase_sprite
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC .data_1,y
	ROL $00
	CMP $D8,x
	PHP
	LDA.W $001D
	LSR $00
	ADC .data_2,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ +
	EOR #$80
	STA $00
+	LDA $00
	BPL .return
	BMI .erase_sprite

.data_1
	db $40,$B0
.data_2
	db $01,$FF
.data_3
	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90	;bank 1 sizes
	db $30,$C0,$A0,$80,$A0,$40,$60,$B0	;bank 3 sizes
.data_4
	db $01,$FF,$01,$FF,$01,$FF,$01,$FF	;bank 1 sizes
	db $01,$FF,$01,$FF,$01,$00,$01,$FF	;bank 3 sizes

; determines which side of the sprite the player is on
; exit conditions:
;	Y = direction (1 = left, 0 = right)
horizontal_position:
	LDY #$00
	LDA $94
	SEC
	SBC $E4,x
	STA $0F
	LDA $95
	SBC $14E0,x
	BPL +
	INY
+	RTL

; determines if the player is above or below the sprite
; exit conditions:
;	Y = direction (0 = below, 1 = above)
vertical_position:
	LDY #$00
	LDA $96
	SEC
	SBC $D8,x
	STA $0F
	LDA $97
	SBC $14D4,x
	BPL +
	INY
+	RTL

; get a random number
; entry conditions:
;	Y = mod value (max+1)
; exit conditions:
;	A = result
get_rand:
	JSL $81ACF9
	LDA !RNG_seed
	STA $4202
	LDA $94
	STA $4203
	NOP #3
	REP #$20
	LDA $4216
	CLC
	ADC $148D
	STA $4204
	SEP #$20
	STY $4206
	NOP #8
	LDA $4216
	STA !RNG_seed
	RTL

; check if the player is in proximity horizontally
; entry conditions:
;	A = distance
; exit conditions:
;	A = result (bool)
;	Y = direction (1 = left, 0 = right)
;	$00 = distance
proximity_x:
	STA $00
	STZ $01
	LDY #$01
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $94
	BPL +
	DEY
	EOR #$FFFF
	INC
+	CMP $00
	STA $00
	SEP #$20
	BCC +
	LDA #$00			;???
	RTL
	
+	LDA #$01
	RTL
	
; check if the player is in proximity vertically
; entry conditions:
;	A = distance
; exit conditions:
; 	A = result (bool)
; 	Y = direction (1 = above, 0 = below)
; 	$00 = distance
proximity_y:
	STA $00
	STZ $01
	LDY #$00
	LDA $14D4,x
	XBA
	LDA $D8,x
	REP #$20
	SEC
	SBC $96
	BPL +
	INY
	EOR #$FFFF
	INC
+	CMP $00
	STA $00
	SEP #$20
	BCC +
	LDA #$00			;???
	RTL
	
+	LDA #$01
	RTL
	
.data
	dw $FFFF,$0000

; get the MAP16 tile located at the sprite's position
; exit conditions:
;	[$6B] = MAP16 number low byte
;	[$6E] = MAP16 number high byte
get_MAP16_sprite:
	LDA $D8,x
	STA $00
	LDA $14D4,x
	STA $01
	LDA $E4,x
	STA $02
	LDA $14E0,x
	STA $03
get_MAP16:
	PHX
	LDA $00
	AND #$F0
	STA $04
	LDA $02
	LSR #4
	ORA $04
	TAX
	LDA $5B
	LSR
	BCC .horizontal_level
	TXA
	LDX $01
	CLC
	ADC $80BA80,x
	STA $6B
	STA $6E
	LDA $80BABC,x
	ADC $03
	STA $6C
	STA $6F
	BRA +

.horizontal_level
	TXA
	LDX $03
	CLC
	ADC $80BA60,x
	STA $6B
	STA $6E
	LDA $80BA9C,x
	ADC $01
	STA $6C
	STA $6F

+	LDA #$7E
	STA $6D
	INC
	STA $70
	PLX
	RTL

; get the acts like of a MAP16 tile
; entry conditions:
;	A = MAP16 tile (16-bit)
;	Y/X must be 16-bit too
; exit conditions:
;	A = acts like
get_acts_like:
	AND #$3FFF
	ASL
	TAY
	LDA $86F624
	STA $0A
	LDA $86F626
	STA $0C
	LDA [$0A],y
	RTL

; ayy lmao
get_sin:
	CLC
	ADC #$00C0
get_cos:
	PHX
	REP #$10
	AND #$00FF
	ASL
	TAX
	LDA.l cos_table,x
	SEP #$10
	PLX
	RTL

cos_table:
	dw $0100,$0100,$0100,$00FF,$00FF,$00FE,$00FD,$00FC
	dw $00FB,$00FA,$00F8,$00F7,$00F5,$00F3,$00F1,$00EF
	dw $00ED,$00EA,$00E7,$00E5,$00E2,$00DF,$00DC,$00D8
	dw $00D5,$00D1,$00CE,$00CA,$00C6,$00C2,$00BE,$00B9
	dw $00B5,$00B1,$00AC,$00A7,$00A2,$009D,$0098,$0093
	dw $008E,$0089,$0084,$007E,$0079,$0073,$006D,$0068
	dw $0062,$005C,$0056,$0050,$004A,$0044,$003E,$0038
	dw $0032,$002C,$0026,$001F,$0019,$0013,$000D,$0006
	dw $0000,$FFFA,$FFF3,$FFED,$FFE7,$FFE1,$FFDA,$FFD4
	dw $FFCE,$FFC8,$FFC2,$FFBC,$FFB6,$FFB0,$FFAA,$FFA4
	dw $FF9E,$FF98,$FF93,$FF8D,$FF87,$FF82,$FF7C,$FF77
	dw $FF72,$FF6D,$FF68,$FF63,$FF5E,$FF59,$FF54,$FF4F
	dw $FF4B,$FF47,$FF42,$FF3E,$FF3A,$FF36,$FF32,$FF2F
	dw $FF2B,$FF28,$FF24,$FF21,$FF1E,$FF1B,$FF19,$FF16
	dw $FF13,$FF11,$FF0F,$FF0D,$FF0B,$FF09,$FF08,$FF06
	dw $FF05,$FF04,$FF03,$FF02,$FF01,$FF01,$FF00,$FF00
	dw $FF00,$FF00,$FF00,$FF01,$FF01,$FF02,$FF03,$FF04
	dw $FF05,$FF06,$FF08,$FF09,$FF0B,$FF0D,$FF0F,$FF11
	dw $FF13,$FF16,$FF19,$FF1B,$FF1E,$FF21,$FF24,$FF28
	dw $FF2B,$FF2F,$FF32,$FF36,$FF3A,$FF3E,$FF42,$FF47
	dw $FF4B,$FF4F,$FF54,$FF59,$FF5E,$FF63,$FF68,$FF6D
	dw $FF72,$FF77,$FF7C,$FF82,$FF87,$FF8D,$FF93,$FF98
	dw $FF9E,$FFA4,$FFAA,$FFB0,$FFB6,$FFBC,$FFC2,$FFC8
	dw $FFCE,$FFD4,$FFDA,$FFE1,$FFE7,$FFED,$FFF3,$FFFA
	dw $0000,$0006,$000D,$0013,$0019,$001F,$0026,$002C
	dw $0032,$0038,$003E,$0044,$004A,$0050,$0056,$005C
	dw $0062,$0068,$006D,$0073,$0079,$007E,$0084,$0089
	dw $008E,$0093,$0098,$009D,$00A2,$00A7,$00AC,$00B1
	dw $00B5,$00B9,$00BE,$00C2,$00C6,$00CA,$00CE,$00D1
	dw $00D5,$00D8,$00DC,$00DF,$00E2,$00E5,$00E7,$00EA
	dw $00ED,$00EF,$00F1,$00F3,$00F5,$00F7,$00F8,$00FA
	dw $00FB,$00FC,$00FD,$00FE,$00FF,$00FF,$0100,$0100
	
; check for contact between A and B
; entry conditions:
;	00 - X low B		01 - Y low B
;	02 - Width B		03 - Height B
;	04 - X low A		05 - Y low A
;	06 - Width A		07 - Height A
;	08 - X high B		09 - Y high B
;	0A - X high A		0B - Y high A
; exit conditions:
;	C = whether there is contact	
;	0C, 0E = x diffs but not exactly
;	0D, 0F = y diffs but not exactly
check_for_contact:
	LDA $01
	SEC
	SBC $05
	PHA
	LDA $09
	SBC $0B
	STA $0D
	PLA
	CLC
	ADC #$80
	LDA $0D
	ADC #$00
	BNE .return
	LDA $05
	SEC
	SBC $01
	CLC
	ADC $07
	STA $0F
	LDA $03
	CLC
	ADC $07
	CMP $0F
	BCC .return

	LDA $00
	SEC
	SBC $04
	PHA
	LDA $08
	SBC $0A
	STA $0C
	PLA
	CLC
	ADC #$80
	LDA $0C
	ADC #$00
	BNE .return
	LDA $04
	SEC
	SBC $00
	CLC
	ADC $06
	STA $0E
	LDA $02
	CLC
	ADC $06
	CMP $0E
	BCC .return
.return
	RTL
