GameOverTxt:
	db "BONUS OVER"
.end

TimeUp:
	db "TIME UP"
.end

MissedTxt:
	db "Time Left:"
.end

Txt1:
	db "^ BONUS GAME >"
Txt2:
	db "Collect as many items as you can"
Txt3:
	db "Use < and > to tilt the platform"
Txt4:
	db "Press B to start"
.end

;; -- Items -- ;;

Txt5:
	db "<    ITEMS   &"
Txt6:
	db "5  Coins"
Txt7:
	db "10 Coins"
Txt8:
	db "15 Coins"
Txt9:
	db "1-Up"
TxtA:
	db "Bigger platform"
TxtB:
	db "Smaller platform"
TxtC:
	db "     Press B to start"
.end

; T = Tile
; P = Properties
; #T #P
; 24,0A - 1-Up
; C2,04 - 5 Coins
; C2,06 - 10 Coins
; C2,08 - 15 Coins
; 80,0B - Bigger platform
; 82,09 - Smaller platform

Items:
	dw $04C2,$06C2,$08C2,$0A24,$0B80,$0982	; Format: [properties][tile]
YX:
	dw $5C04,$6C04,$7C04,$5C6C,$6C6C,$7C6C	; Format: [Ypos][Xpos]
.end

TxtXPos:
	db $48,$00,$00,$40,$48,$18,$18,$18,$80,$80,$80,$18
; TXT # 1   2   3   4   5   6   7   8   9   A   B   C
TxtYPos:
	db $40,$60,$70,$98,$40,$60,$70,$80,$60,$70,$80,$98
; TXT # 1   2   3   4   5   6   7   8   9   A   B   C
TxtSze:
	db Txt2-Txt1,Txt3-Txt2,Txt4-Txt3,Txt4_end-Txt4,Txt6-Txt5,Txt7-Txt6,Txt8-Txt7,Txt9-Txt8,TxtA-Txt9,TxtB-TxtA,TxtC-TxtB,TxtC_end-TxtC
.end
TextIndx:
	db $00,$04
TextIndx2:
	db $00,Txt4_end-Txt1

PlaceItems:
	LDX #$0000
	REP #$20	; > A 16-bit
-	LDA YX,x
	STA !textOAM,y
	LDA Items,x
	STA !textOAM+2,y
	TYA : LSR #2
	PHY : TAY
	LDA #$0202
	STA !textSZE,y
	PLY
	INY #4
	INX #2
	CPX #YX_end-YX
	BNE -
	RTS

; > Draw Text routine. This will draw Txt1 - Txt4 or Txt5 - TxtB (depending on input A (0,1))
DrawText:
	TAX
	LDA TextIndx,x
	STA $02
	TAY
	LDA TextIndx2,x
	TAX
	REP #$10	; > 16-bit X/Y
	TDC	; > Clear A (Transfer direct page to 16-bit A)
	LDA TxtXPos,y
	STA $00
	LDA TxtYPos,y
	STA $01
	LDA TxtSze,y
	STA $03
	LDY #$0000	; > Clear Y
-	CPY.w #!skipOAM
	BNE +
	LDY.w #!OAMresume
+	LDA Txt1,x
	STA !textOAM+2,y
	LDA #$31
	STA !textOAM+3,y
	LDA $00
	STA !textOAM,y
	CLC : ADC #$08
	STA $00
	LDA $01
	STA !textOAM+1,y
	TYA
	LSR #2
	PHX
	TAX
	LDA #$00
	STA !textSZE,x
	PLX
	
	TYA
	LSR #2
	PHY : TAY
	LDA #$00
	STA !textSZE,y
	PLY
	
	INY #4
	INX
	DEC $03
	BNE -
	INC $02
	LDA $02
	CMP.b #TxtSze_end-TxtSze
	BEQ .done
	CPX #Txt4_end-Txt1
	BEQ .done
	PHY : TAY
	LDA TxtSze,y
	STA $03
	LDA TxtXPos,y
	STA $00
	LDA TxtYPos,y
	STA $01
	PLY
	BRA -
.done
	LDA !page
	BEQ .reallyDone
	JSR PlaceItems
.reallyDone
	SEP #$30
	RTS

DrawTimeUp:
	PHP
	SEP #$30
	LDX #$00 : TXY
	LDA #!TimeUpX
	STA $00
-	LDA $00
	STA !TimeUpOAM,y
	CLC : ADC #$08
	STA $00
	LDA #!TimeUpY
	STA !TimeUpOAM+1,y
	LDA TimeUp,x
	STA !TimeUpOAM+2,y
	LDA #$31
	STA !TimeUpOAM+3,y
	INY #4
	INX : CPX.b #TimeUp_end-TimeUp
	BNE -
	PLP
	RTS

DrawLives:
	REP #$20
	LDA #!speedUp
	SEC : SBC !timer
	LSR #6	; > Slow down to about a second (64 frames so 1 second and 4 frames but eh close enough)
	CMP #$0005
	SEP #$20
	BCS .return
	ASL
	CLC : ADC #$60
	STA !missedOAM+2,y
	LDA $13
	LSR #1
	AND #$01
	EOR #!missedX
	STA !missedOAM,y
	LDA $13
	LSR #1
	AND #$01
	EOR #!missedY
	STA !missedOAM+1,y
	LDA #$31
	STA !missedOAM+3,y
	TYA : LSR #2 : TAY
	LDA #$02
	STA !missedSZE,y
;	PHA
;	LDX #$00 : TXY
;	LDA #!missedX
;	STA $00
;-	LDA $00
;	STA !missedOAM,y
;	CLC : ADC #$08
;	STA $00
;	LDA #!missedY
;	STA !missedOAM+1,y
;	LDA MissedTxt,x
;	STA !missedOAM+2,y
;	LDA #$31
;	STA !missedOAM+3,y
;	INY #4
;	INX : CPX.b #MissedTxt_end-MissedTxt
;	BNE -
;	PLA
;	CLC : ADC #$31
;	STA !missedOAM+2,y
;	LDA $00
;	STA !missedOAM,y
;	LDA #!missedY
;	STA !missedOAM+1,y
;	LDA #$31
;	STA !missedOAM+3,y
.return
	RTS

DrawGameOver:
	LDA !spdUpTxt
	BEQ .normalGameOver
	JMP DrawTimeUp
.normalGameOver
	LDX #$00 : TXY
	LDA #!gmOvrX
	STA $00
-	LDA $00
	STA !gmOvrOAM,y
	CLC : ADC #$08
	STA $00
	LDA #!gmOvrY
	STA !gmOvrOAM+1,y
	LDA GameOverTxt,x
	STA !gmOvrOAM+2,y
	LDA #$31
	STA !gmOvrOAM+3,y
	LDA #$00
	STA !gmOvrSZE,x
	INY #4
	INX : CPX.b #GameOverTxt_end-GameOverTxt
	BNE -
	RTS