;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This block will spawn a puump bubble if hit while lit up.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Effect information
!hitSFX		=	$29
!hitPort	=	$1DFC

; Map16 tile numbers for each of the three fuel blocks.
!blockA		=	$0200
!blockB		=	$0201
!blockC		=	$0202
!maxHits	=	15

; The first manual trigger. All three should be consecutive.
!manual		=	$7FC070

; Spawn data for the bubble.
!bubbleSpr	=	$02
!bubbleX	=	$8C
!bubbleY	=	$0DA7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
!blkCount	=	$1442
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

db $42
	JMP MarioBelow : JMP Return : JMP Return : JMP Return : JMP Return
	JMP Return : JMP Return : JMP Return : JMP Return : JMP Return

MarioBelow:
	LDA !blkCount	;\ 
	CMP #!maxHits	;| Cap hits.
	BEQ Return		;/
	
	LDA $7D
	BPL Return
	
	;; Figure out what manual trigger to use.
	REP #$20
	LDX #$00
	LDA $03
	CMP #!blockA
	BEQ BlockFound
	LDX #$01
	CMP #!blockB
	BEQ BlockFound
	LDX #$02
	CMP #!blockC
	BEQ BlockFound
	SEP #$20
Return:
	RTL
	
BlockFound:
	;;; Return if corresponding trigger isn't set
	SEP #$20
	LDA !manual,x
	BEQ Return
	
	INC !blkCount
	LDA !blkCount
	CMP #!maxHits
	BNE .notMaxed
	STA !manual
	STA !manual+1
	STA !manual+2
	BRA .spawnBubble
	
  .notMaxed
	LDA #$00
	STA !manual,x
	JSL $01ACF9		; rng
	LDA $148D
	STA $4202
	LDA #$03
	STA $4203
	NOP #4
	LDX $4217
	LDA !blkCount
	CMP #$0F
	STA !manual,x
	
	;; Spawn the pump bubble.
  .spawnBubble
	PHY
	JSL $02A9E4		; find a free slot
	BMI Return
	TYX
	PLY
	LDA #$01
	STA $14C8,x
	LDA #!bubbleSpr
	STA $7FAB9E,x
	LDA.b #!bubbleX
	STA $E4,x
	STZ $14E0,x
	LDA.b #!bubbleY
	STA $D8,x
	LDA.b #!bubbleY>>8
	STA $14D4,x
	JSL $07F7D2		; init sprite tables
	JSL $0187A7		; init custom sprite tables
	LDA #$08
	STA $7FAB10,x
	
	;; Effectwork
	LDA #!hitSFX
	STA !hitPort
	%glitter()
	RTL


print "This block will send fuel to the ship if hit while its corresponding manual trigger is set."