;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; A pump bubble which flows from the lab to the ship.
;;
;; Should really be an extended sprite but, eh.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!speed		=	$20
!rocketX	=	$B0		; xpos of the rocket
!fuel		=	$08		; value to store to the animation timer

!doneSFX	=	$06		; SFX for entering the ship
!donePort	=	$1DF9

!tile		=	$04
!prop		=	$25

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!fuelTimer	=	$1441	; ram timer for increasing the fuel




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; code begins
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc
	LDA #!speed
	STA $B6,x
	RTL
	
print "MAIN ",pc
	LDA $9D
	BNE +
	JSL $018022			; update xpos
	
	LDA $E4,x			;\ 
	CMP #!rocketX		;|
	BCC +				;| If at the rocket, increase the fuel tank.
	LDA #!fuel			;|
	STA !fuelTimer		;|
	STZ $14C8,x			;/
	LDA #!doneSFX
	STA !donePort
	
  +
	JSR Graphics
	RTL



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Graphics:
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $0300,y
	LDA $D8,x
	SEC
	SBC $1C
	STA $0301,y
	LDA #!tile
	STA $0302,y
	LDA #!prop
	STA $0303,y
	TYA
	LSR #2
	TAY
	LDA #$00
	STA $0460,y
	RTS