;disable interrupts (decompression takes a while)
	STZ $4200

;clear cluster sprite tables for use as free RAM
	LDX #$73
	-
	STZ $0F4A,x
	DEX : BPL -

;enable mode 7
	LDA #$07
	STA $3E

;decompress and upload mode 7 tilemap
	LDA #$71 : STA $02
	REP #$20
	STZ $00
	LDA #$0083
	JSL $0FF900
	SEP #$20
	STZ $2115
	REP #$20
	STZ $2116
	LDA #$1800 : STA $4310
	STZ $4312
	LDY #$71 : STY $4314
	LDA #$4000 : STA $4315
	SEP #$20
	LDA #$02 : STA $420B

;decompress and upload mode 7 graphics
	LDA #$71 : STA $02
	REP #$20
	STZ $00
	LDA #$0084
	JSL $0FF900
	SEP #$20
	LDA #$80 : STA $2115
	REP #$20
	STZ $2116
	LDA #$1900 : STA $4310
	STZ $4312
	LDY #$71 : STY $4314
	LDA #$4000 : STA $4315
	SEP #$20
	LDA #$02 : STA $420B

;initialize several mode 7 register mirrors
	REP #$20
	STZ $2A
	STZ $2C
	STZ $3A
	STZ $3C
	LDA #$2020
	STA $38
	STZ $36

;reposition mario
	LDA $94
	CLC : ADC #$0008
	STA $94
	LDA $96
	CLC : ADC #$0010
	STA $96
	SEP #$20

;decompress and upload sprite graphics
	LDA #$71 : STA $02
	REP #$20
	STZ $00
	LDA #$0081
	JSL $0FF900
	SEP #$20
	LDA #$80 : STA $2115
	REP #$20
	LDA #$5000 : STA $2116
	LDA #$1801 : STA $4310
	STZ $4312
	LDY #$71 : STY $4314
	LDA #$6000 : STA $4315
	SEP #$20
	LDA #$02 : STA $420B

;set up letterbox window (helps limit viewable tilemap and also covers up sprite shenanigans)
	REP #$20
	LDA #$2801 : STA $4330
	LDA.w #.windowtable : STA $4332
	SEP #$20
	PHK : PLA : STA $4334
	LDA #$80 : STA $43
	LDA #$52 : STA $44
	LDA #$08 : TSB $0D9F

;force visible layers onto subscreen so color 0 has priority
	STZ $212C : STZ $0D9D
	LDA #$13 : STA $212D : STA $0D9E

;change FirstSprite to one closer to mario's oam, giving earlier OAM tiles (used as BG) less priority
	LDA #$80 : STA $3F

;change sprite-layer priority to make Mario appear below mode 7 extbg but above mode 7
	LDA #$10 : STA $64

;initializing a few of the free RAM addresses
	REP #$20
	LDA #$0018 : STA !XPos
	LDA #$FFC0 : STA !YPos
	LDA #$00C0 : STA $36
	SEP #$20
	LDA #$10 : STA !rotspeed

;force small mario with no item box item for compatibility reasons (but back them up)
	LDA $19 : STA !powerup
	STZ $19
	LDA $0DC2 : STA !itembox
	STZ $0DC2

;upload the map16 table and animation GFX
	STZ $00
	LDA #$AD : STA $01
	LDA #$7E : STA $02
	REP #$20
	LDA #$0082
	JSL $0FF900
	SEP #$20

;reenable interrupts
	LDA #$81 : STA $4200
	RTS

.windowtable
	db $10,$FF,$00
	db $80,$10,$EF
	db $40,$10,$EF
	db $10,$FF,$00
	db $00