InteractionHandler:
	JSR .pointP
	JSR .pointC
	JSR .pointD
	JSR .pointH
	STZ !CoinGrab
	STZ !pointcheck
	JSR .checkpointC
	INC !pointcheck
	JSR .checkpointD
	INC !pointcheck
	JSR .checkpointP
	INC !pointcheck
	JSR .checkpointH
	STZ !pointcheck
	JSR .checkpointC
	INC !pointcheck
	JSR .checkpointD
	RTS

macro map16grab(pointX, pointY)
	REP #$30
	LDA <pointX>
	AND #$03FF
	LSR #4 : STA $00
	LDA <pointY>
	AND #$03F0
	ASL #2
	CLC : ADC $00
	TAX
	SEP #$20
	LDA !Map16,x
	STA $0F
	STX $0D
	SEP #$10
endmacro

.pointP
	REP #$20
	LDA !XPos
	CLC : ADC #$0080
	STA !pointP_X
	LDA !YPos
	CLC : ADC #$0080
	STA !pointP_Y
	SEP #$20
	RTS

.pointH
	REP #$21
	LDA $36
	EOR #$01FF
	ADC #$0180
	STA $04
	SEP #$20
	LDA #$10 : STA $06
	JSR circleY
	JSR circleX
	REP #$10
	JSR .point_store
	STX !pointH_X
	STY !pointH_Y
	SEP #$10
	RTS

.pointC
	REP #$21
	LDA $36
	EOR #$01FF
	ADC #$014C
	STA $04
	SEP #$20
	LDA #$0A : STA $06
	JSR circleY
	JSR circleX
	REP #$10
	JSR .point_store
	STX !pointC_X
	STY !pointC_Y
	SEP #$10
	RTS

.pointD
	REP #$21
	LDA $36
	EOR #$01FF
	ADC #$01B4
	STA $04
	SEP #$20
	LDA #$0A : STA $06
	JSR circleY
	JSR circleX
	REP #$10
	JSR .point_store
	STX !pointD_X
	STY !pointD_Y
	SEP #$10
	RTS

.point_store
	LDA #$FF
	BIT $07 : BMI +
	INC
	+
	XBA
	LDA $07
	REP #$21
	ADC !XPos
	ADC #$0080
	TAX
	SEP #$20
	LDA #$FF
	BIT $08 : BMI +
	INC
	+
	XBA
	LDA $08
	REP #$21
	ADC !YPos
	ADC #$0080
	TAY
	SEP #$20
	RTS

.checkpointC
	%map16grab(!pointC_X, !pointC_Y)
	ASL : TAX
	LDA #$02
	JMP (.map16handler,x)

.checkpointD
	%map16grab(!pointD_X, !pointD_Y)
	ASL : TAX
	LDA #$01
	JMP (.map16handler,x)

.checkpointP
	%map16grab(!pointP_X, !pointP_Y)
	ASL : TAX
	LDA #$04
	JMP (.map16handler,x)

.checkpointH
	%map16grab(!pointH_X, !pointH_Y)
	ASL : TAX
	LDA #$08
	JMP (.map16handler,x)


.map16handler
	dw .air
	dw .solid
	dw .coin
	dw .muncher
	dw .music
	dw .invisible
	dw .round
	dw .moon
	dw .questionblue
	dw .questionyellow
	dw .questionred
	dw .questiongreen
	dw .invrotate
	dw .onblock
	dw .offblock

.invisible
	LDX #$01
	STX !InvisiBlockContact

.air
	TRB !Solid
	RTS

.coin
	TRB !Solid
	LDA !CoinGrab
	BNE +
	INC !CoinGrab
	LDX #$09
-
	LDA !collecttable,x
	BEQ +++
	DEX #3 : BPL -
	LDA #$00
	JSR BlockVRAMConvert
	BRA ++
+++
	PHX
	LDA #$04
	JSR BlockVRAMConvert
	PLX
	LDA #$0C : STA !collecttable,x
	LDA $0D : STA !collecttable+1,x
	LDA $0E : STA !collecttable+2,x
++
	LDA #$01
	STA $1DFC
	STA $13CC
	REP #$10
	LDX $0D
	LDA #$00
	STA !Map16,x
	SEP #$10
+
-
	RTS

.muncher
.moon
	PLA : PLA
	TXA : LSR #3 : INC
	STA !endlevel
	DEC : BEQ +
	LDA #$03
	STA $18E4
+
	LDA #$70
	STA $14AB
	LDA #$1E
	STA $1DF9
	RTS

.music
	TSB !Solid
	LDA #$08
	STA $1DFC
	LDA !pointcheck : TAX
	LSR : TAY
	LDA ..musicspeed,x : STA !XSpeed,y
	TYA : BNE ..musicy
..musicx
	LDA #$40 : STA !DisableFlag
	RTS
..musicy
	BCS ..ceiling
	LDA #$1F : STA !JumpTimer
	STA !JumpFlag
	STZ !HitHeadFlag
	LDA #$04 : TRB !Solid
	RTS	
..ceiling
	STA !NoBonk
	RTS
..musicspeed
	db $30,$D0,$D0,$30

.invrotate
	LDY !pointcheck : CPY #$02
	BCC .solid
	CPY #$03
	BEQ ..ceiling
	LDY !SpinJump
	BEQ .solid
	TRB !Solid
	LDA #$1C
	STA $1DFC
	LDA !Direction
	EOR #$01
	STA !Direction
	LDA #$1F : STA !JumpTimer
	LDA #$D0 : STA !YSpeed
	STA !JumpFlag
	STZ !HitHeadFlag
	RTS
..ceiling
	LDY !JumpFlag
	BEQ .solid
	LDY !HitHeadFlag
	BNE .solid
	PHA
	LDA #$1C
	STA $1DFC
	LDA !Direction
	EOR #$01
	STA !Direction
	PLA

.solid
.round
	TSB !Solid
	LDA !XSpeed : PHA
	LDA !YSpeed : PHA
	LDA !pointcheck : TAX
	LDA ..ysp,x : STA !YSpeed
	LDA ..xsp,x : STA !XSpeed
	-
	REP #$20
	LDA !XPos : STA !XPosPrev
	LDA !YPos : STA !YPosPrev
	SEP #$20
	JSR PositionHandler
	LDA !pointcheck : ASL #2 : TAX
	PHX
	JSR (..repoint,x)
	PLX
	JSR (..repoint+2,x)
	LDY $0F
	BEQ +
	CPY #$02
	BEQ +
	CPY #$05
	BEQ +
	BRA -
	+
	REP #$20
	LDA !XPosPrev : STA !XPos
	LDA !YPosPrev : STA !YPos
	SEP #$20
	PLA
	LDX !pointcheck
	CPX #$03
	BEQ +
	STA !YSpeed
	+
	PLA : STA !XSpeed
	RTS

..xsp
	db $08,$F8,$00,$00
..ysp
	db $00,$00,$F8,$10

..repoint
	dw .pointC,..remapC
	dw .pointD,..remapD
	dw .pointP,..remapP
	dw .pointH,..remapH

..remapC
	%map16grab(!pointC_X, !pointC_Y)
	RTS
..remapD
	%map16grab(!pointD_X, !pointD_Y)
	RTS
..remapP
	%map16grab(!pointP_X, !pointP_Y)
	RTS
..remapH
	%map16grab(!pointH_X, !pointH_Y)
	RTS

.questionblue
.questionyellow
.questionred
.questiongreen
	LDY $0F
	TSB !Solid
	LDX !pointcheck : CPX #$02
	BCC ..end
	CPX #$03
	BEQ ..bottom
	LDX !SpinJump
	BEQ ..end
	TRB !Solid
	LDA #$1F : STA !JumpTimer
	LDA #$D0 : STA !YSpeed
	LDA #$01 : STA !JumpFlag
	STZ !HitHeadFlag
	JMP ..questionblock
..bottom
	LDA !JumpFlag
	BEQ ..end
	LDA !HitHeadFlag
	BNE ..end
	JSR ..questionblock
	STA !NoBonk
	LDA #$08
..end
	JMP .solid

..questionblock
	INY
	CPY #$0C
	BCC +
	LDY #$00
	+
	TYA
	REP #$10
	LDX $0D
	STA !Map16,x
	SEP #$10
	AND #$03
	TAX
	LDA ..qtable,x
	JSR BlockVRAMConvert
	LDA #$10
	STA $1DF9
	RTS
..qtable
	db $00,$08,$0C,$10

.onblock
	LDY $0F
	TSB !Solid
	LDX !pointcheck : CPX #$02
	BCC ..end
	CPX #$03
	BEQ ..bottom
	LDX !SpinJump
	BEQ ..end
	TRB !Solid
	LDA #$1F : STA !JumpTimer
	LDA #$D0 : STA !YSpeed
	LDA #$01 : STA !JumpFlag
	STZ !HitHeadFlag
	JMP ..onblock
..bottom
	LDA !JumpFlag
	BEQ ..end
	LDA !HitHeadFlag
	BNE ..end
	JSR ..onblock
	STA !NoBonk
	LDA #$08
..end
	JMP .solid

..onblock
	LDA !rotspeed
	CLC : ADC #$04
	CMP #$20
	BCC +
	INY : TYA
	REP #$10
	LDX $0D
	STA !Map16,x
	SEP #$10
	LDA #$1C
	JSR BlockVRAMConvert
	LDA !rotspeed
	+
	STA !rotspeed
	LDA #$0A
	STA $1DF9
	RTS

.offblock
	LDY $0F
	TSB !Solid
	LDX !pointcheck : CPX #$02
	BCC ..end
	CPX #$03
	BEQ ..bottom
	LDX !SpinJump
	BEQ ..end
	TRB !Solid
	LDA #$1F : STA !JumpTimer
	LDA #$D0 : STA !YSpeed
	LDA #$01 : STA !JumpFlag
	STZ !HitHeadFlag
	JMP ..offblock
..bottom
	LDA !JumpFlag
	BEQ ..end
	LDA !HitHeadFlag
	BNE ..end
	JSR ..offblock
	STA !NoBonk
	LDA #$08
..end
	JMP .solid

..offblock
	LDA !rotspeed
	SEC : SBC #$04
	CMP #$09
	BCS +
	DEY : TYA
	REP #$10
	LDX $0D
	STA !Map16,x
	SEP #$10
	LDA #$20
	JSR BlockVRAMConvert
	LDA !rotspeed
	+
	STA !rotspeed
	LDA #$04
	STA $1DF9
	RTS