; This patch makes it so that SMW's Mode 7 mirrors as well as rotation and scaling routines can be used in any level where the BG Mode ($3E) is set to 7. It also disables ExAnimation in those levels. The last section actually inserts Mode 7 graphics and tilemap into the game, but this can be disabled by simply removing it.

header
lorom


!freespace = $258000

;-------------------------------------

org $80FFD8
	db $07	;sram size

org $8081C6
	autoclean JML MirrorCheck
	NOP

org $8082DF
	NOP #3	;JSR $98A9

org $80A28A
	autoclean JML ScrollRotateCheck
	NOP

org $80A5AF
	autoclean JML ExAnimCheck
	NOP
	
org $808387
	autoclean JML Mode7Pos

org $809A6F
	autoclean JSL spritefix

org $8083BF
autoclean JML spriteirqhijack

org $80834B
autoclean JML spritenmihijack
	NOP #2

org $809079
autoclean JML itembox	;LDY #$E0
NOP			;BIT $0D9B



freecode

itembox:
LDA $010B
BEQ +
LDY #$E0
BIT $0D9B
JML $80907E
+
JML $8090D0

;-------------------------------------

spritenmihijack:
LDA $010B
BNE +
LDA $4211
LDA #$62 : STA $2101
LDY #$50
STY $4209
STZ $420A
LDA $0DAE
STA $2100
LDA $0D9F
STA $420C
LDA #$A1
JML $8083F3
+
LDA $0DAE
STA $2100
JML $808351

spriteirqhijack:
LDY $010B
BNE +
;LDY #$22
;- DEY : BPL -
LDY #$63 : STY $2101
JML $8083B2
+
LDY $11
BEQ +
JML $8083C3
+
JML $8083D0


; This makes SMW use the Mode 7 mirrors in ANY Mode 7 level instead
; of just boss levels.

spritefix:
LDA $010B
BEQ +
JSL $7F8000
+
RTL

MirrorCheck:
	LDA $3E
	AND #$07
	CMP #$07
	BEQ .mode7levelpre
	LDA $0D9B
	BMI .mode7level
	JML $8081CE

.mode7levelpre
	LDA #$C1

.mode7level
	STA $0D9B
	JML $8082C4
	
Mode7Pos:
	LDA $3E
	AND #$07
	CMP #$07
	BEQ .mode7level
	LDA $0D9B
	BMI .mode7level
	LDA #$81
	STA $4200
	JML $80838F

.mode7level
	LDA #$81
	JML $8083BA

;-------------------------------------

; Turns off scrolling in Mode 7 levels (this function is disabled!)
; and handles rotation and scaling.

ScrollRotateCheck:
	LDA $3E
	AND #$07
	CMP #$07
	BEQ .mode7level
	LDA $0D9B
	BMI .bosslevel
	JML $80A295

.mode7level
	PHK
	PER $0006
	PEA $84CE	;PLB : RTL
	JML $80987D	;JSL to RTS
	JML $80A295

.bosslevel
	PHK
	PER $0006
	PEA $84CE	;PLB : RTL
	JML $80987D	;JSL to RTS
	JML $80A2A9

;-------------------------------------

; Turns off ExAnimation in Mode 7 levels.

ExAnimCheck:
	LDA $3E
	AND #$07
	CMP #$07
	BEQ .mode7level
	LDA $0D9B
	BMI .mode7level
	JML $80A5B9

.mode7level
	JML $80A5B4

;-------------------------------------

;org !freespace+$010000

; Actual Mode 7 graphics go here. They take up a full bank and
; therefore have to go at the beginning of one.

;incbin Graphics.bin
;incbin Tilemap.bin